### Class

# FwupdPlugin CfuOffer

#### Description [src]

    class FwupdPlugin.CfuOffer : FwupdPlugin.Firmware
    {
      /* No available fields */
    }

A CFU offer. This is a 16 byte blob which contains enough data for the device to either accept or refuse a firmware payload. The offer may be loaded from disk, network, or even constructed manually. There is much left to how the specific firmware implements CFU, and it’s expected that multiple different plugins will use this offer in different ways.

Documented: https://docs.microsoft.com/en-us/windows-hardware/drivers/cfu/cfu-specification

See also: `FuFirmware`.

#### Ancestors

- FuFirmware
- GObject

#### Constructors

###### fu_cfu_offer_new

Creates a new `FuFirmware` for a CFU offer.

since: 1.7.0

#### Functions

###### fu_cfu_offer_info_code_to_string

Converts an enumerated value to a string.

###### fu_cfu_offer_status_to_string

Converts an enumerated value to a string.

#### Instance methods

###### fu_cfu_offer_get_bank

Gets the bank register, used if multiple banks are supported.

since: 1.7.0

###### fu_cfu_offer_get_component_id

Gets the component in the device to apply the firmware update.

since: 1.7.0

###### fu_cfu_offer_get_force_ignore_version

Gets if the in-situ firmware should ignore version mismatch (e.g. downgrade).

since: 1.7.0

###### fu_cfu_offer_get_force_immediate_reset

Gets if the in-situ firmware should reset into the new firmware immediately, rather than waiting for the next time the device is replugged.

since: 1.7.0

###### fu_cfu_offer_get_hw_variant

Gets the hardware variant bitmask corresponding with compatible firmware.

since: 1.7.0

###### fu_cfu_offer_get_milestone

Gets the milestone, which can be used as a version for example EV1, EVT etc.

since: 1.7.0

###### fu_cfu_offer_get_product_id

Gets the product ID for this CFU image.

since: 1.7.0

###### fu_cfu_offer_get_protocol_revision

Gets the CFU protocol version.

since: 1.7.0

###### fu_cfu_offer_get_segment_number

Gets the part of the firmware that is being transferred.

since: 1.7.0

###### fu_cfu_offer_get_token

Gets the token to identify the user specific software making the offer.

since: 1.7.0

###### fu_cfu_offer_set_bank

Sets bank register, used if multiple banks are supported.

since: 1.7.0

###### fu_cfu_offer_set_component_id

Sets the component in the device to apply the firmware update.

since: 1.7.0

###### fu_cfu_offer_set_force_ignore_version

Sets if the in-situ firmware should ignore version mismatch (e.g. downgrade).

since: 1.7.0

###### fu_cfu_offer_set_force_immediate_reset

Sets if the in-situ firmware should reset into the new firmware immediately, rather than waiting for the next time the device is replugged.

since: 1.7.0

###### fu_cfu_offer_set_hw_variant

Sets the hardware variant bitmask corresponding with compatible firmware.

since: 1.7.0

###### fu_cfu_offer_set_milestone

Sets the milestone, which can be used as a version for example EV1, EVT etc.

since: 1.7.0

###### fu_cfu_offer_set_product_id

Sets the product ID for this CFU image.

since: 1.7.0

###### fu_cfu_offer_set_protocol_revision

Sets the CFU protocol version.

since: 1.7.0

###### fu_cfu_offer_set_segment_number

Sets the part of the firmware that is being transferred.

since: 1.7.0

###### fu_cfu_offer_set_token

Sets the token to identify the user specific software making the offer.

since: 1.7.0

##### Methods inherited from FuFirmware (66)

Please see FuFirmware for a full list of methods.

##### Methods inherited from GObject (43)

Please see GObject for a full list of methods.

#### Properties

##### Properties inherited from FuFirmware (1)

###### FwupdPlugin.Firmware:parent

The firmware parent.

since: 1.8.2

#### Signals

##### Signals inherited from GObject (1)

###### GObject::notify

The notify signal is emitted on an object when one of its properties has its value set through g_object_set_property(), g_object_set(), et al.

#### Class structure

    struct FwupdPluginCfuOfferClass {
      FuFirmwareClass parent_class;

    }

No description available.

###### Class members

`parent_class: FuFirmwareClass`

  No description available.